import { CallOptions, ExtraOptions, MakeRequired, RSA, RSN } from "./utils";
import type { Path, Validate } from "./validate";
export declare type Guard<Type, Options extends RSA = RSN> = Validate<Type, CallOptions<Type, Options>, false>;
export declare type GuardOptions<Name extends keyof vality.guards, G = vality.guards[Name]> = G extends Guard<infer Type, infer Options> ? [Type, Options] : G extends (...args: any[]) => Guard<infer Type, infer Options> ? [Type, Options] : never;
export declare function guard<Name extends keyof vality.guards, Type extends GuardOptions<Name>[0], Options extends RSA & GuardOptions<Name>[1]>(name: Name, guardFn: (value: unknown, options: Partial<CallOptions<Type, Options>>, path: Path, parent?: any) => Type | undefined, handleOptions?: {
    [K in Exclude<keyof Options, keyof ExtraOptions<Type, Options>>]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K> & Partial<ExtraOptions<Type, Options>>) => boolean;
}, defaultOptions?: Partial<Options>): Validate<Type, Options, false>;
