"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.guard = void 0;
const utils_1 = require("./utils");
function guard(name, guardFn, handleOptions, defaultOptions) {
    return (0, utils_1.makeValit)(name, fn => (value, options, path, parent) => {
        const res = fn(value, options, path, parent);
        if ((0, utils_1.isValid)(res))
            return {
                valid: true,
                data: res,
                errors: []
            };
        return {
            valid: false,
            data: undefined,
            errors: [
                {
                    message: `vality.${name}.base`,
                    path,
                    options,
                    value,
                },
            ],
        };
    }, handleOptions, defaultOptions)(guardFn);
}
exports.guard = guard;
