import { Face, Path, Validate, ValidateFn, ValidationResult } from "./validate";
export declare type RSA = Record<string, any>;
export declare type RSN = Record<string, never>;
export declare type RSE = {
    [K: string]: Eny;
};
export declare type MaybeArray<T> = T | T[];
export declare type Primitive = string | number | boolean | null;
export declare type _Eny = Primitive | Face<Primitive, any> | (() => RSE) | RSE;
export declare type Eny = MaybeArray<_Eny> | Readonly<MaybeArray<_Eny>>;
export declare type MakeRequired<T extends RSA, K extends keyof T> = {
    [key in K]-?: T[key];
} & {
    [key in Exclude<keyof T, K>]: T[key];
};
export declare function assert<T>(val: any, condition?: boolean): asserts val is T;
export declare function isValid<Type>(data: Type | undefined): data is Type;
export declare type EnyToFace<T> = T extends [infer U] ? Face<U[], true> : T extends [...infer U] ? Face<U, true> : T extends Primitive ? Face<T, false> : T extends Face<any, any> ? T : T extends () => infer U ? Face<U, true> : Face<T, true>;
export declare function enyToGuard<E extends Eny>(eny: E): EnyToFace<E>;
export declare function enyToGuardFn<E extends Eny>(e: E): ValidateFn<any>;
export declare function flat<T>(arr: T[][]): T[];
export declare type IdentityFn<T> = (x: T) => T;
export declare function identity<T>(x: T): T;
export declare function trueFn(..._args: any[]): true;
export declare function falseFn(..._args: any[]): false;
export declare type ExtraOptions<T, O> = {
    transform: IdentityFn<T>;
    default: T;
    validate: (val: T, options: CallOptions<T, O>) => boolean;
};
export declare type CallOptions<Type, Options> = Options extends RSN ? ExtraOptions<Type, Options> : Options & Omit<ExtraOptions<Type, Options>, keyof Options>;
export declare type ValitParameters<Name, Arg extends any[], Type, Options extends RSA> = [
    Name,
    (...args: Arg) => (val: unknown, options: Partial<CallOptions<Type, Options>>, path: Path, parent?: any) => ValidationResult<Type>,
    {
        [K in Exclude<keyof Options, keyof ExtraOptions<Type, Options>>]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K> & Partial<ExtraOptions<Type, Options>>) => boolean;
    }?,
    Partial<Options>?
];
export declare function makeValit<Name extends keyof (vality.valits & vality.guards), Arg extends any[], Type, Options extends RSA, V extends boolean>(...[name, fn, handleOptions, defaultOptions]: ValitParameters<Name, Arg, Type, Options>): (...args: Arg) => Validate<Type, Options, V>;
