"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeValit = exports.falseFn = exports.trueFn = exports.identity = exports.flat = exports.enyToGuardFn = exports.enyToGuard = exports.isValid = exports.assert = void 0;
const symbols_1 = require("./symbols");
const vality_1 = require("./vality");
function assert(val, condition) {
    if (condition === false) {
        throw new Error("Assertion failed");
    }
}
exports.assert = assert;
function isValid(data) {
    return data !== undefined;
}
exports.isValid = isValid;
function enyToGuard(eny) {
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array short");
        if (eny.length === 1)
            return vality_1.vality.array(enyToGuard(eny[0]));
        return vality_1.vality.enum(...eny.map(enyToGuard));
    }
    if (typeof eny === "string" || typeof eny === "number" || typeof eny === "boolean" || eny === null)
        return vality_1.vality.literal(eny);
    if (symbols_1._validate in eny)
        return eny;
    if (typeof eny === "function")
        return vality_1.vality.relation(eny);
    return vality_1.vality.object(eny);
}
exports.enyToGuard = enyToGuard;
function enyToGuardFn(e) {
    return enyToGuard(e)[symbols_1._validate];
}
exports.enyToGuardFn = enyToGuardFn;
function flat(arr) {
    return [].concat(...arr);
}
exports.flat = flat;
function identity(x) {
    return x;
}
exports.identity = identity;
function trueFn(..._args) {
    return true;
}
exports.trueFn = trueFn;
function falseFn(..._args) {
    return false;
}
exports.falseFn = falseFn;
function makeValit(...[name, fn, handleOptions, defaultOptions]) {
    return (...args) => {
        const getValidateFnFromOptions = (options) => (value, path, parent) => {
            const data = fn(...args)(value, options, path, parent);
            if (!data.valid) {
                if (value === undefined && options.default !== undefined) {
                    return { valid: true, data: options.default, errors: [] };
                }
                return data;
            }
            const origData = data.data;
            if (options.validate && !options.validate(origData, options)) {
                return {
                    valid: false,
                    data: undefined,
                    errors: [
                        {
                            message: `vality.${name}.custom`,
                            path,
                            options,
                            value,
                        },
                    ],
                };
            }
            if (options.transform) {
                data.data = options.transform(data.data);
            }
            if (handleOptions === undefined)
                return data;
            const optionsWithDefault = Object.assign(Object.assign({}, defaultOptions), options);
            const keysWithError = Object.keys(optionsWithDefault).filter(k => k !== "transform" &&
                k !== "validate" &&
                k !== "default" &&
                handleOptions[k] !== undefined && !handleOptions[k](origData, optionsWithDefault[k], options));
            if (keysWithError.length === 0)
                return data;
            return {
                valid: false,
                data: undefined,
                errors: keysWithError.map(k => ({
                    message: k in options ? `vality.${name}.options.${k}` : `vality.${name}.base`,
                    options,
                    path,
                    value,
                })),
            };
        };
        return Object.assign((options) => {
            return {
                [symbols_1._validate]: (val, path, parent) => {
                    if (typeof options === "function")
                        options = options(parent);
                    return getValidateFnFromOptions(options)(val, path, parent);
                },
                [symbols_1._type]: undefined,
            };
        }, {
            [symbols_1._validate]: getValidateFnFromOptions({}),
            [symbols_1._type]: undefined,
        });
    };
}
exports.makeValit = makeValit;
