import { ParseIn } from "./parse";
import { _readonly, _type, _validate, _valit } from "./symbols";
import { CallOptions, Eny } from "./utils";
export interface Error {
    message: string;
    path: Path;
    options: unknown;
    value: unknown;
}
export declare type Validate<T, O, V extends boolean> = Face<T, V> & ((options: Partial<CallOptions<T, O>> | ((parent: any) => Partial<CallOptions<T, O>>)) => Face<T, V>);
export declare type Face<T, V extends boolean> = {
    [_validate]: ValidateFn<T>;
    [_type]: T;
    [_readonly]?: false;
    [_valit]?: V;
};
export declare type ValidateFn<T> = (val: unknown, path: Path, parent: any) => ValidationResult<T>;
export declare type ValidationResult<T> = {
    valid: true;
    data: T;
    errors: never[];
} | {
    valid: false;
    data: undefined;
    errors: Error[];
};
export declare type Path = (string | number)[];
export declare function validate<E extends Eny>(schema: E, val: unknown, bail?: boolean): ValidationResult<ParseIn<E>>;
